<?php // $Id: docs.php,v 1.4 2004/04/24 18:18:21 janne Exp $
//
// Files and folders routines for JulmaCMS
// Very strong influence from (tm) Moodle
// http://moodle.org ((C) Martin Dougiamas)
//

include("../config.php");
include("../lib/mime.php");
include("error.php");
include("admin.php");
define("REDIRECT", $CFG->web ."/admin/docs.php");
define("SOURCE", basename($_SERVER['PHP_SELF']));

session_name($CFG->prefix ."Session");
session_start();

if(!$_SESSION['logged']) {
    header ("Location: http://". $_SERVER['HTTP_HOST'] ."/". dirname($_SERVER['PHP_SELF']) . "/logout.php");
}
$themedir = $CFG->path ."/themes";

if(!($conf = get_config())) {
    error(get_string("noconfig","error"),REDIRECT,SOURCE);
    exit;
}

$conf->theme = "admin";
$basedir = $CFG->dir;
$ulcount = 0;
$taso = 3;

include($themedir ."/admin/header.html");
?>
    <table width="100%" border="0" cellspacing="0" cellpadding="0" height="100%">
    <tr>
    <td class="news" width="200" valign="top"><?php print_admin_links();?></td>
    <td width="560" class="main" valign="top">
    <h3><?php output("sitefiles","sitefiles");?></h3>
<?php

function get_filesize($path) {
    if(file_exists($path)) {
        $size = filesize($path);
    } else {
        $size = 0;
    }
    // Turn size to kilobytes
    $size = round($size / 1024);
    return $size;
}

function makenavi($path) {
    if(isset($path) and !empty($path)) {
        $path = substr($path, 1, strlen($path));
        $dirs = explode("/", $path);
        print "<strong> <a href=\"{$_SERVER['PHP_SELF']}?a=1&sdir=\">".get_string("rootdirectory","sitefiles")."</a></strong>\n";
        $dircount = count($dirs);
        for($i = 0; $i < $dircount; $i++) {
            $newpath .= "/".$dirs[$i];
            if($i < ($dircount - 1)) {
                print " / <strong><a href=\"{$_SERVER['PHP_SELF']}?a=1&sdir=$newpath\">$dirs[$i]</a></strong>\n";
            } else {
                print " / <strong>$dirs[$i]</strong>\n";
            }
        }
    } else {
        print "<strong>".get_string("rootdirectory","sitefiles")."</strong>\n";
    }
}

function showDir($dir) {

    global $CFG, $ulcount,$basedir, $taso;

    $navipath = str_replace($basedir, "", $dir);
    makenavi($navipath);

    print "<table border=\"0\" width=\"100%\">\n";
    print "<tr>\n";
    print "<th width=\"2%\">&nbsp;</td>\n";
    print "<th align=\"left\">&nbsp;</th>\n";
    print "<th align=\"left\" width=\"10%\">".get_string("size","sitefiles")."</th>\n";
    print "<th align=\"left\" width=\"15%\">".get_string("modified","sitefiles")."</th>\n";
    print "<th align=\"left\" width=\"25%\">".get_string("action","sitefiles")."</th>\n";
    print "</tr>\n";

    // Show directories
    if($dh = opendir($dir)) {
        while(($file = readdir($dh)) !== false) {
            $fc = substr($file,0,1);

            if($fc == ".") {
                continue;
            } else {
                if(filetype($dir ."/". $file) == "dir") {
                    $newpath = $dir ."/". $file;
                    $modified = date("j.n.y H:i", filectime($newpath));
                    $newpath = str_replace($basedir,"", $newpath);
                    $dname = basename($newpath);
                    print "<tr>\n";
                    print "<td width=\"2%\"><!-- <input type=\"checkbox\"> --></td>\n";
                    print "<td><a href=\"{$_SERVER['PHP_SELF']}?a=1&sdir=$newpath\">";
                    print "<img src=\"pix/folder.gif\" border=\"0\" alt=\"$newpath\" width=\"19\"";
                    print " height=\"17\" align=\"absmiddle\"></a>";
                    print " <a href=\"{$_SERVER['PHP_SELF']}?a=1&sdir=$newpath\">$dname</a></td>\n";
                    print "<td>&nbsp;&nbsp;&nbsp; - </td>\n";
                    print "<td>$modified</td>\n";
                    print "<td>( <a href=\"{$_SERVER['PHP_SELF']}";
                    print "?a=remove&url=$newpath&type=dir\">".get_string("delete")."</a> |";
                    print " <a href=\"{$_SERVER['PHP_SELF']}?a=rename&url=$newpath\">".get_string("rename")."</a> )</td>\n";
                    print "</tr>\n";
                }
            }
        }
        // Show files in current directory
        rewinddir($dh);
        while(($file = readdir($dh)) !== false) {
            $fc = substr($file,0,1);

            if($fc == ".") {
                continue;
            } else {
                if(filetype($dir ."/". $file) == "file") {

                    $furl = str_replace($basedir,"",$dir);
                    $furl = $furl ."/".$file;
                    $modified = date("j.n.y H:i", filectime($basedir.$furl));
                    $size = get_filesize($basedir.$furl);
                    $image = mimetype("image", $file);
                    print "<tr>\n";
                    print "<td width=\"2%\"><!-- <input type=\"checkbox\"> --></td>\n";
                    print "<td><a href=\"file.php?file=$furl\">";
                    print "<img src=\"pix/$image\" alt=\"$file\" border=\"0\"";
                    print " width=\"19\" height=\"17\" align=\"absmiddle\"></a>";
                    print "&nbsp;&nbsp;<a href=\"file.php?file=$furl\">$file</a></td>\n";
                    print "<td>$size kt</td>\n";
                    print "<td>$modified</td>\n";
                    print "<td>( <a href=\"{$_SERVER['PHP_SELF']}";
                    print "?a=remove&url=$furl&type=file\">".get_string("delete")."</a> |";
                    print " <a href=\"{$_SERVER['PHP_SELF']}?a=rename&url=$furl\">".get_string("rename")."</a> )</td>\n";
                    print "</tr>\n";

                }
            }
        }
    }
    closedir($dh);
    print "</table>\n";
    $updir = str_replace($basedir,"",$dir);
    include("html/form.html");
    unset($dir,$fc,$newpath,$dname,$file);
}

function rn($old, $new) {
// rename selected file or folder

    if(isset($old) && !empty($new)) {
        if(!rename($old, $new)) {
            return false;
        }
    } else {
        return false;
    }
    return true;
}

function delete_dir($dir) {
// delete folder and every subfolders and files.

    global $basedir;
    $path = $basedir . $dir;

    $dh = opendir($path) or die("Couldn't open directory $path");

    while(($file = readdir($dh)) !== false) {
        if($file != "." && $file != "..") {
            $fullfile = $path."/".$file;
            if(filetype($fullfile) == "dir") {
                delete_dir($dir."/".$file);
                if(!@rmdir($fullfile)) {
                    //return false;
                }

            } else {
                if(!@unlink("$fullfile")) {
                    // return false;
                }
            }
        }
    }
    closedir($dh);
    if(!rmdir($path)) {
        return false;
    }
    return true;
    unset($dir,$path,$file);
}

function delete_file($url) {
    // delete requested file

    global $basedir;
    $file = $basedir . $url;
    if(!unlink($file)) {
        return false;
    }
    return true;
}

function confirm_delete($url,$type="file")  {
   include("html/deleteform.html");
}

function rename_form($sdir) {
    $name = basename($sdir);
    include("html/rnform.html");
}

if(isset($_GET['a'])) {

    switch($_GET['a']) {
        case "remove":
            confirm_delete($_GET['url'], $_GET['type']);
            break;
        case "rename":
            rename_form($_GET['url']);
            break;
        default:
        if(isset($_GET['sdir']) && $_GET['sdir'] != "") {
            showDir($basedir . $_GET['sdir']);
        } else {
            showDir($basedir);
        }
    }
} else if(isset($_POST['action'])) {
    switch($_POST['action']) {
        case "mkdir":
            if(isset($_POST['newfolder']) && !empty($_POST['newfolder'])) {
                if(mkdir($basedir.$_POST['sdir']."/".$_POST['newfolder'])) {
                    showDir($basedir.$_POST['sdir']);
                } else {
                    print "<p>Kansion ". $_POST['newfolder'] ." luonti ei onnistunut!</p>\n";
                }
            } else {
                showDir($basedir.$_POST['sdir']);
            }
            break;
        case "upload":
            if(is_uploaded_file($_FILES['fiilu']['tmp_name'])) {
                if(eregi("(\.[mdb$|avi$|mpg$|mpeg$|tar$|tar\.gz$|pdf$|doc$|txt$|css$|htm$|html$|rtf$|xls$|ppt$|dot$|zip$|jpg$|jpeg$|gif$|png$]{3,})",$_FILES['fiilu']['name'])) {
                    if(!move_uploaded_file($_FILES['fiilu']['tmp_name'],$basedir.$_POST['sdir']."/".$_FILES['fiilu']['name'])) {
                        print "<p>Tiedoston {$_FILES['fiilu']['name']} lataus palvelimelle ei onnistunut!</p>\n";
                        error(get_string("fileuploadfailed","error"),REDIRECT,SOURCE);
                        break;
                    }
                } else {
                    $msg =  "<p>".get_string("uploading","sitefiles")." ";
                    $msg .= get_string("file1","sitefiles") . " ";
                    $msg .= $_FILES['fiilu']['name'];
                    $msg .= " ". get_string("securedeny","sitefiles"). "</p>";
                    error($msg,REDIRECT,SOURCE);
                    break;
                }
            }
            showDir($basedir.$_POST['sdir']);
            break;
        case "delete":
            if(isset($_POST['sdir']) && $_POST['sdir'] != "") {
                if($_POST['isdir'] != "true") {
                    if(!delete_file($_POST['sdir'])) {
                        error(get_string("filedeletefailed","error"),REDIRECT,SOURCE);
                        break;
                    }
                    $sdir = str_replace("/".basename($_POST['sdir']),"",$_POST['sdir']);
                    showDir($basedir.$sdir);
                } else {
                    if(!delete_dir($_POST['sdir'])) {
                        error(get_string("dirdeletefailed","error"),REDIRECT,SOURCE);
                        break;
                    }
                    $sdir = str_replace("/".basename($_POST['sdir']), "",$basedir.$_POST['sdir']);
                    showDir($sdir);
                }
            }
            break;
        case "rename":
            if(isset($_POST['newname']) && !empty($_POST['newname'])) {
                $nname = str_replace(basename($_POST['sdir']), $_POST['newname'], $_POST['sdir']);
                if(!rn($basedir.$_POST['sdir'],$basedir.$nname)) {
                    error(get_string("renamefailed","error"),REDIRECT,SOURCE);
                    break;
                } else {
                    $parts = pathinfo($nname);
                    showDir($basedir.$parts['dirname']);
                }
            } else {
                showDir($basedir);
            }
            break;
        default:
            if(isset($_POST['sdir'])) {
                $parts = pathinfo($_POST['sdir']);
                showDir($basedir.$parts['dirname']);
            } else {
                showDir($basedir);
            }
    }
} else {
    showDir($basedir);
}
    ?>
    </td>
    <td>&nbsp;</td>
    </tr>
    </table>
    <?php
include($themedir ."/admin/footer.html");
?>
