<?php // $Id: core.php,v 1.4 2004/04/24 18:18:23 janne Exp $
// Core functions for JulmaCMS

/*
* function get_config(). This function gets all configuration values
* from database as $name and $value pair as an object.
* @return object Returns an object like $obj->sitename
*/
function get_config() {
    global $CFG;
    static $counter;
    $sql = "SELECT name,value FROM ".$CFG->prefix."cms_config ORDER BY id";
    $result = makeQuery($sql);
    if(!$result) {
        return false;
    } else {
        while($row = mysql_fetch_assoc($result)) {
            $test->{$row['name']} = $row['value'];
        }
        return $test;
    }
    unset($result, $row, $test);
    $counter++;
    echo $counter;
}

/*
* function makeDate(). generate SQL database DATE type date.
* @return string Current date in form YYYY-MM-DD
*/
function makeDate() {
    $returndate = date("Y-m-d");
    return $returndate;
}

/*
* function _datetime() Generate SQL database DATETIME type date value.
* @return string Current date in form YYYY-MM-DD hours:mins:secs
*/
function _datetime() {
    $datetime = date("Y-m-d H:i:s");
    return $datetime;

    unset($datetime);
}

/* function parseDate(). Translates given date to SQL database DATE or
* DATETIME type date.
* @param string $iDate Input date to translate.
* @param integer $iTime Translate type 0=DATE,1=DATETIME
* @return string DATE or DATETIME date value for SQL database.
*/
function parseDate($idate,$itime=0) {
    list ($day, $month, $year) = split ('[/.-]', $idate);
    $day = trim($day);
    $month = trim($month);
    $year = trim($year);
    if($month < 10) {
        $month = 0 . $month;
    }
    if($day < 10) {
        $day = 0 .  $day;
    }
    if(strlen($year) < 4) {
        $new = date("Y");
        $year = substr($new, 0, 2) . $year;
    }
    $pvm = "$year-$month-$day";
    if(!$itime) {
        return $pvm;
    } else {
        $pvm .= $pvm ." ". date("H:i:s");
        return $pvm;
    }
}

/*
* function printDate() Prints out a date.
* 1. Day: number of day without leading zero.
* 2. Month: number of month without leading zero.
* 3. Year: four digit year.
* @return string Return current date (form 1.1.2004)
*/
function printDate() {
    $pvm = date("j.n.Y");
    return $pvm;
}

/*
* function convertDate(). Converts DATE type to finnish style date eg.
* 1.1.2004
* @param string $iDate Date to convert.
* @return string Converted date.
*/
function convertDate($idate) {
    if($idate == "0000-00-00") {
        $cdate = "";
    } else {
        $cdate = date("j.n.Y", strtotime($idate));
    }
    return $cdate;
}

/* function convert_mysql_timestamp(). Converts timestamp to regular date.
* @param string $iStamp Timestamp to convert.
* @return string Date. Form of date is DD.MM.YYYY H:M:S
*/
function convert_mysql_timestamp($istamp) {
    ereg("^([0-9]{4})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})$",$istamp,$regs);
    $year = $regs[1];
    $month = $regs[2];
    $day = $regs[3];
    $hour = $regs[4];
    $min = $regs[5];
    $sec = $regs[6];

    $pvm = $day.".".$month.".".$year." ".$hour.":".$min.":".$sec;

    return $pvm;
}
/* function convert_datetime(). Converts DATETIME to regular date
* @param string $iDate DATETIME to convert.
* @return string Date in form DD.MM.YYYY
*/
function convert_datetime($idate) {
    ereg("^([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2})\:([0-9]{2})\:([0-9]{2})$",$idate,$regs);
    $year = $regs[1];
    $month = $regs[2];
    $day = $regs[3];
    $hour = $regs[4];
    $min = $regs[5];
    $sec = $regs[6];

    $pvm = $day.".".$month.".".$year;

    return $pvm;
}
/* function image_size(). Gets logo.gif's size values.
* @return string Returns string width="width" height="height".
*/
function image_size() {
    global $CFG, $conf;
    $image = $CFG->path ."/themes/" . $conf->theme ."/logo.gif";
    $size = getimagesize($image);
    $strsize = $size[3];
    return $strsize;
    unset($conf,$themedir,$image,$pic,$size,$strsize);
}

/*
* function list_themes() Lists themes in a select field.
* Lists every folder in themes -directory exept admin.
* @param string $currenttheme Currently used themename
* @return void Does not return any value. Prints out select's option values.
*/
function list_themes($currenttheme) {

    global $CFG;
    $themepath = $CFG->path ."/themes";

    $handle = opendir($themepath) or die("Couldn't open directory $themepath");

    while(($file = readdir($handle)) !== false) {
        $fc = substr($file,0,1);
        if($fc == ".") {
            continue;
        }
        if(filetype($themepath ."/". $file) == "dir") {
            $dirs[] = $file;
        }
    }
    if(!empty($dirs)) {
        foreach($dirs as $d) {
            if($d != "admin") {
                print($d == $currenttheme)?
                "<option value=\"$d\" selected>$d</option>\n":
                "<option value=\"$d\">$d</option>\n";
            }
        }
    }
}

/*
* function require_login(). Checks if user is logged in
* @return boolean Returns true or false. True if session is valid
* and false if session is invalid.
*/
function require_login() {
    if(!$_SESSION['logged'] && session_name() != $CFG->prefix."Session") {
        return false;
    } else {
        return true;
    }
}

/*
* function get_string(). Gets the requested language string.
* @param string $langstring
* @param string $langfile
* @return string string
*/
function get_string($langstring,$langfile="") {

    global $CFG;

    if(empty($langfile)) {
        $langfile = "main";
    }

    if(empty($langstring)) {
        print " String not specified!";
    }

    include($CFG->path."/lang/".$CFG->lang."/".$langfile.".php");
    if($string[$langstring] != "") {
        return stripslashes($string[$langstring]);
    } else {
        $string = "[ not specified ]";
        return $string;
    }
}

function output($string, $langfile="") {
    // Prints out the requested string from langfiles
    if(empty($langfile)) {
        $langfile = "main";
    }
    print(get_string($string, $langfile));
}
?>