<?php
// $Id: mime.php,v 1.4 2004/04/24 18:18:23 janne Exp $
///////////////////////////////////////////////////////////////////////////
//                                                                       //
// FUNCTION ORIGIN AND NOTICE OF COPYRIGHT                               //
//                                                                       //
// Function origin moodle.org files/mimetypes.php                        //                                               //
// Moodle - Modular Object-Oriented Dynamic Learning Environment         //
//          http://moodle.org                                            //
//                                                                       //
// Copyright (C) 1999-2004  Martin Dougiamas  http://dougiamas.com       //
//                                                                       //
//                                                                       //
//          http://www.gnu.org/copyleft/gpl.html                         //
//                                                                       //
///////////////////////////////////////////////////////////////////////////

/*
 * function mimetype
 * @param string $element "mime" or "image"
 * @param string $filename filename to comare with.
 * @return array Returns an array. Type of file or icon imagename.
*/
function mimetype($element, $filename) {
    $mimetype = array (
        "xxx"  => array ("mime"=>"document/unknown", "image"=>"unknown.gif"),
        "ai"   => array ("mime"=>"application/postscript", "image"=>"img.gif"),
        "aif"  => array ("mime"=>"audio/x-aiff", "image"=>"audio.gif"),
        "aiff" => array ("mime"=>"audio/x-aiff", "image"=>"audio.gif"),
        "aifc" => array ("mime"=>"audio/x-aiff", "image"=>"audio.gif"),
        "applescript"  => array ("mime"=>"text/plain", "image"=>"file.gif"),
        "asc"  => array ("mime"=>"text/plain", "image"=>"file.gif"),
        "au"   => array ("mime"=>"audio/au", "image"=>"audio.gif"),
        "avi"  => array ("mime"=>"video/x-ms-wm", "image"=>"avi.gif"),
        "bmp"  => array ("mime"=>"image/bmp", "image"=>"img.gif"),
        "cs"   => array ("mime"=>"application/x-csh", "image"=>"file.gif"),
        "css"  => array ("mime"=>"text/css", "image"=>"file.gif"),
        "dv"   => array ("mime"=>"video/x-dv", "image"=>"video.gif"),
        "doc"  => array ("mime"=>"application/msword", "image"=>"doc.gif"),
        "dif"  => array ("mime"=>"video/x-dv", "image"=>"video.gif"),
        "eps"  => array ("mime"=>"application/postscript", "image"=>"img.gif"),
        "gif"  => array ("mime"=>"image/gif", "image"=>"img.gif"),
        "gtar" => array ("mime"=>"application/x-gtar", "image"=>"zip.gif"),
        "gzip" => array ("mime"=>"application/g-zip", "image"=>"zip.gif"),
        "h"    => array ("mime"=>"text/plain", "image"=>"file.gif"),
        "hqx"  => array ("mime"=>"application/mac-binhex40", "image"=>"zip.gif"),
        "html" => array ("mime"=>"text/html", "image"=>"html.gif"),
        "htm"  => array ("mime"=>"text/html", "image"=>"html.gif"),
        "jpe"  => array ("mime"=>"image/jpeg", "image"=>"img.gif"),
        "jpeg" => array ("mime"=>"image/jpeg", "image"=>"img.gif"),
        "jpg"  => array ("mime"=>"image/jpeg", "image"=>"img.gif"),
        "js"   => array ("mime"=>"application/x-javascript", "image"=>"file.gif"),
        "latex"=> array ("mime"=>"application/x-latex", "image"=>"file.gif"),
        "m"    => array ("mime"=>"text/plain", "image"=>"file.gif"),
        "mdb"  => array ("mime"=>"application/vnd.ms-access", "image"=>"dbase.gif"),
        "mov"  => array ("mime"=>"video/quicktime", "image"=>"video.gif"),
        "movie"=> array ("mime"=>"video/x-sgi-movie", "image"=>"video.gif"),
        "m3u"  => array ("mime"=>"audio/x-mpegurl", "image"=>"audio.gif"),
        "mp3"  => array ("mime"=>"audio/mp3", "image"=>"audio.gif"),
        "mp4"  => array ("mime"=>"video/mp4", "image"=>"video.gif"),
        "mpeg" => array ("mime"=>"video/mpeg", "image"=>"video.gif"),
        "mpe"  => array ("mime"=>"video/mpeg", "image"=>"video.gif"),
        "mpg"  => array ("mime"=>"video/mpeg", "image"=>"video.gif"),
        "pct"  => array ("mime"=>"image/pict", "image"=>"img.gif"),
        "pdf"  => array ("mime"=>"application/pdf", "image"=>"pdf.gif"),
        "php"  => array ("mime"=>"text/plain", "image"=>"file.gif"),
        "pic"  => array ("mime"=>"image/pict", "image"=>"img.gif"),
        "pict" => array ("mime"=>"image/pict", "image"=>"img.gif"),
        "png"  => array ("mime"=>"image/png", "image"=>"img.gif"),
        "ppt"  => array ("mime"=>"application/vnd.ms-powerpoint", "image"=>"ppt.gif"),
        "ps"   => array ("mime"=>"application/postscript", "image"=>"img.gif"),
        "qt"   => array ("mime"=>"video/quicktime", "image"=>"video.gif"),
        "ra"   => array ("mime"=>"audio/x-realaudio", "image"=>"audio.gif"),
        "ram"  => array ("mime"=>"audio/x-pn-realaudio", "image"=>"audio.gif"),
        "rm"   => array ("mime"=>"audio/x-pn-realaudio", "image"=>"audio.gif"),
        "rtf"  => array ("mime"=>"text/rtf", "image"=>"doc.gif"),
        "rtx"  => array ("mime"=>"text/richtext", "image"=>"file.gif"),
        "sh"   => array ("mime"=>"application/x-sh", "image"=>"file.gif"),
        "sit"  => array ("mime"=>"application/x-stuffit", "image"=>"zip.gif"),
        "smi"  => array ("mime"=>"application/smil", "image"=>"file.gif"),
        "smil" => array ("mime"=>"application/smil", "image"=>"file.gif"),
        "swf"  => array ("mime"=>"application/x-shockwave-flash", "image"=>"flash.gif"),
        "tar"  => array ("mime"=>"application/x-tar", "image"=>"zip.gif"),
        "tif"  => array ("mime"=>"image/tiff", "image"=>"img.gif"),
        "tiff" => array ("mime"=>"image/tiff", "image"=>"img.gif"),
        "tex"  => array ("mime"=>"application/x-tex", "image"=>"file.gif"),
        "texi" => array ("mime"=>"application/x-texinfo", "image"=>"file.gif"),
        "texinfo"  => array ("mime"=>"application/x-texinfo", "image"=>"file.gif"),
        "tsv"  => array ("mime"=>"text/tab-separated-values", "image"=>"file.gif"),
        "txt"  => array ("mime"=>"text/plain", "image"=>"file.gif"),
        "wav"  => array ("mime"=>"audio/wav", "image"=>"audio.gif"),
        "xls"  => array ("mime"=>"application/vnd.ms-excel", "image"=>"xls.gif"),
        "xml"  => array ("mime"=>"text/xml", "image"=>"xml.gif"),
        "xsl"  => array ("mime"=>"text/xml", "image"=>"xml.gif"),
        "zip"  => array ("mime"=>"application/zip", "image"=>"zip.gif")
    );

    if (eregi("\.([a-z0-9]{2,})$", $filename, $match)) {
        $result = $mimetype[strtolower($match[1])][$element];
    }

    if (!empty($result)) {
        return $result;
    } else {
        return $mimetype["xxx"][$element];   // By default
    }
}
?>