<?php
// $Id: mime_bak.php,v 1.4 2004/04/24 18:18:23 janne Exp $
// $Revision: 1.4 $

/*
 * function mimeinfo
 * @param string $element "type" or "icon"
 * @param string $filename filename to comare with.
 * @return array Returns an array. Type of file or icon imagename.
*/
function mimeinfo($element, $filename) {
    $mimeinfo = array (
        "xxx"  => array ("type"=>"document/unknown", "icon"=>"unknown.gif"),
        "ai"   => array ("type"=>"application/postscript", "icon"=>"img.gif"),
        "aif"  => array ("type"=>"audio/x-aiff", "icon"=>"audio.gif"),
        "aiff" => array ("type"=>"audio/x-aiff", "icon"=>"audio.gif"),
        "aifc" => array ("type"=>"audio/x-aiff", "icon"=>"audio.gif"),
        "applescript"  => array ("type"=>"text/plain", "icon"=>"file.gif"),
        "asc"  => array ("type"=>"text/plain", "icon"=>"file.gif"),
        "au"   => array ("type"=>"audio/au", "icon"=>"audio.gif"),
        "avi"  => array ("type"=>"video/x-ms-wm", "icon"=>"avi.gif"),
        "bmp"  => array ("type"=>"image/bmp", "icon"=>"img.gif"),
        "cs"   => array ("type"=>"application/x-csh", "icon"=>"file.gif"),
        "css"  => array ("type"=>"text/css", "icon"=>"file.gif"),
        "dv"   => array ("type"=>"video/x-dv", "icon"=>"video.gif"),
        "doc"  => array ("type"=>"application/msword", "icon"=>"doc.gif"),
        "dif"  => array ("type"=>"video/x-dv", "icon"=>"video.gif"),
        "eps"  => array ("type"=>"application/postscript", "icon"=>"img.gif"),
        "gif"  => array ("type"=>"image/gif", "icon"=>"img.gif"),
        "gtar" => array ("type"=>"application/x-gtar", "icon"=>"zip.gif"),
        "gzip" => array ("type"=>"application/g-zip", "icon"=>"zip.gif"),
        "h"    => array ("type"=>"text/plain", "icon"=>"file.gif"),
        "hqx"  => array ("type"=>"application/mac-binhex40", "icon"=>"zip.gif"),
        "html" => array ("type"=>"text/html", "icon"=>"html.gif"),
        "htm"  => array ("type"=>"text/html", "icon"=>"html.gif"),
        "jpe"  => array ("type"=>"image/jpeg", "icon"=>"img.gif"),
        "jpeg" => array ("type"=>"image/jpeg", "icon"=>"img.gif"),
        "jpg"  => array ("type"=>"image/jpeg", "icon"=>"img.gif"),
        "js"   => array ("type"=>"application/x-javascript", "icon"=>"file.gif"),
        "latex"=> array ("type"=>"application/x-latex", "icon"=>"file.gif"),
        "m"    => array ("type"=>"text/plain", "icon"=>"file.gif"),
        "mdb"  => array ("type"=>"application/vnd.ms-access", "icon"=>"dbase.gif"),
        "mov"  => array ("type"=>"video/quicktime", "icon"=>"video.gif"),
        "movie"=> array ("type"=>"video/x-sgi-movie", "icon"=>"video.gif"),
        "m3u"  => array ("type"=>"audio/x-mpegurl", "icon"=>"audio.gif"),
        "mp3"  => array ("type"=>"audio/mp3", "icon"=>"audio.gif"),
        "mp4"  => array ("type"=>"video/mp4", "icon"=>"video.gif"),
        "mpeg" => array ("type"=>"video/mpeg", "icon"=>"video.gif"),
        "mpe"  => array ("type"=>"video/mpeg", "icon"=>"video.gif"),
        "mpg"  => array ("type"=>"video/mpeg", "icon"=>"video.gif"),
        "pct"  => array ("type"=>"image/pict", "icon"=>"img.gif"),
        "pdf"  => array ("type"=>"application/pdf", "icon"=>"pdf.gif"),
        "php"  => array ("type"=>"text/plain", "icon"=>"file.gif"),
        "pic"  => array ("type"=>"image/pict", "icon"=>"img.gif"),
        "pict" => array ("type"=>"image/pict", "icon"=>"img.gif"),
        "png"  => array ("type"=>"image/png", "icon"=>"img.gif"),
        "ppt"  => array ("type"=>"application/vnd.ms-powerpoint", "icon"=>"ppt.gif"),
        "ps"   => array ("type"=>"application/postscript", "icon"=>"img.gif"),
        "qt"   => array ("type"=>"video/quicktime", "icon"=>"video.gif"),
        "ra"   => array ("type"=>"audio/x-realaudio", "icon"=>"audio.gif"),
        "ram"  => array ("type"=>"audio/x-pn-realaudio", "icon"=>"audio.gif"),
        "rm"   => array ("type"=>"audio/x-pn-realaudio", "icon"=>"audio.gif"),
        "rtf"  => array ("type"=>"text/rtf", "icon"=>"doc.gif"),
        "rtx"  => array ("type"=>"text/richtext", "icon"=>"file.gif"),
        "sh"   => array ("type"=>"application/x-sh", "icon"=>"file.gif"),
        "sit"  => array ("type"=>"application/x-stuffit", "icon"=>"zip.gif"),
        "smi"  => array ("type"=>"application/smil", "icon"=>"file.gif"),
        "smil" => array ("type"=>"application/smil", "icon"=>"file.gif"),
        "swf"  => array ("type"=>"application/x-shockwave-flash", "icon"=>"flash.gif"),
        "tar"  => array ("type"=>"application/x-tar", "icon"=>"zip.gif"),
        "tif"  => array ("type"=>"image/tiff", "icon"=>"img.gif"),
        "tiff" => array ("type"=>"image/tiff", "icon"=>"img.gif"),
        "tex"  => array ("type"=>"application/x-tex", "icon"=>"file.gif"),
        "texi" => array ("type"=>"application/x-texinfo", "icon"=>"file.gif"),
        "texinfo"  => array ("type"=>"application/x-texinfo", "icon"=>"file.gif"),
        "tsv"  => array ("type"=>"text/tab-separated-values", "icon"=>"file.gif"),
        "txt"  => array ("type"=>"text/plain", "icon"=>"file.gif"),
        "wav"  => array ("type"=>"audio/wav", "icon"=>"audio.gif"),
        "xls"  => array ("type"=>"application/vnd.ms-excel", "icon"=>"xls.gif"),
        "xml"  => array ("type"=>"text/xml", "icon"=>"xml.gif"),
        "xsl"  => array ("type"=>"text/xml", "icon"=>"xml.gif"),
        "zip"  => array ("type"=>"application/zip", "icon"=>"zip.gif")
    );

    if (eregi("\.([a-z0-9]+)$", $filename, $match)) {
        $result = $mimeinfo[strtolower($match[1])][$element];
    }

    if (!empty($result)) {
        return $result;
    } else {
        return $mimeinfo["xxx"][$element];   // By default
    }
}
?>