#
# Table structure for table 'prefix_cms_config'
#

DROP TABLE IF EXISTS prefix_cms_config;
CREATE TABLE prefix_cms_config (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(64) NOT NULL default '',
  value varchar(255) default NULL,
  PRIMARY KEY  (id),
  UNIQUE KEY name (name),
  KEY cms_config_idx (name)
) TYPE=MyISAM;



#
# Dumping data for table 'prefix_cms_config'
#

INSERT INTO prefix_cms_config (id, name, value) VALUES("1", "sitename", "Your sitename");
INSERT INTO prefix_cms_config (id, name, value) VALUES("2", "logoalign", "left");
INSERT INTO prefix_cms_config (id, name, value) VALUES("3", "theme", "orangegray");
INSERT INTO prefix_cms_config (id, name, value) VALUES("4", "linkalign", "right");
INSERT INTO prefix_cms_config (id, name, value) VALUES("5", "news", "News");
INSERT INTO prefix_cms_config (id, name, value) VALUES("6", "news_amount", "1");
INSERT INTO prefix_cms_config (id, name, value) VALUES("7", "sitemail", "your@site.mail");


#
# Table structure for table 'prefix_cms_news'
#

DROP TABLE IF EXISTS prefix_cms_news;
CREATE TABLE prefix_cms_news (
  id int(10) unsigned NOT NULL auto_increment,
  title varchar(64) NOT NULL default 'Not Defined',
  dated datetime NOT NULL default '0000-00-00 00:00:00',
  content blob,
  created timestamp(14) NOT NULL,
  modified timestamp(14) NOT NULL,
  PRIMARY KEY  (id),
  KEY title_idx (title)
) TYPE=MyISAM;

#
# Table structure for table 'prefix_cms_pages'
#

DROP TABLE IF EXISTS prefix_cms_pages;
CREATE TABLE prefix_cms_pages (
  id int(10) unsigned NOT NULL auto_increment,
  title varchar(64) NOT NULL default 'Not Defined',
  body mediumblob,
  isfp tinyint(1) unsigned NOT NULL default '0',
  sort int(10) unsigned NOT NULL default '0',
  created timestamp(14) NOT NULL,
  modified timestamp(14) NOT NULL,
  hide tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY title_idx (title)
) TYPE=MyISAM;

#
# Dumping data for table 'prefix_cms_pages'
#

INSERT INTO prefix_cms_pages (id, title, body, isfp, sort, created, modified, hide) VALUES("100", "Default", "\r\n<h3>Under construction</h3>", "1", "1", now(), now(), "0");


#
# Table structure for table 'prefix_cms_subpages'
#

DROP TABLE IF EXISTS prefix_cms_subpages;
CREATE TABLE prefix_cms_subpages (
  id int(10) unsigned NOT NULL auto_increment,
  title varchar(64) NOT NULL default 'Not Defined',
  body mediumblob,
  tlid int(10) unsigned NOT NULL default '0',
  sort int(10) unsigned NOT NULL default '0',
  created timestamp(14) NOT NULL,
  modified timestamp(14) NOT NULL,
  hide tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY title_idx (tlid,title)
) TYPE=MyISAM;

#
# Table structure for table 'prefix_cms_users'
#

DROP TABLE IF EXISTS prefix_cms_users;
CREATE TABLE prefix_cms_users (
  id int(10) unsigned NOT NULL auto_increment,
  login varchar(32) NOT NULL default '',
  passwd varchar(32) NOT NULL default '',
  fname varchar(64) default NULL,
  sname varchar(100) default NULL,
  email varchar(100) default NULL,
  phone varchar(64) default NULL,
  gsm varchar(64) default NULL,
  created timestamp(14) NOT NULL,
  modified timestamp(14) NOT NULL,
  lastlogin timestamp(14) NOT NULL,
  PRIMARY KEY  (id),
  UNIQUE KEY login (login),
  KEY cms_users_idx (login,passwd)
) TYPE=MyISAM;



#
# Dumping data for table 'prefix_cms_users'
#

INSERT INTO prefix_cms_users (id, login, passwd, fname, sname, email, phone, gsm, created, modified, lastlogin) VALUES("1", "admin","21232f297a57a5a743894a0e4a801fc3", "Admin", "Mainuser", "postmaster@site.mail", "", "", now(), now(), now());
