<?php
// $Id: weblib.php,v 1.4 2004/04/24 18:18:23 janne Exp $
//
// weblib.php include functions that is used to output data on
// webpages execpt admin pages.
//

include_once("tags.php");

/*
 * Returns a hexadecimal value of color.
 * Used to generate different background colors to html tables.
 * @param string $one optional value of first color
 * @param string $two optional value of second color
 * @return string $color Returns a color value like #ffffff.
*/
function set_color($one="#ffffff",$two="#f5f5f5") {
    static $color; // static value of last used color
    if($color == $one) {
        $color = $two;
    } else {
        $color = $one;
    }
    return $color;
}
/*
 * function get_link_array() Gets an array of page titles and
 * id's for smarty object, which is used to create links to pages.
 * @return array $rivi Array of id's and pagetitles.
*/
function get_link_array() {

    global $CFG; // Global $CFG values.
    $rivi = array();

    $sql = "SELECT id, title, isfp FROM ".$CFG->prefix."cms_pages ";
    $sql .= "WHERE hide != '1' ORDER BY sort ASC";

    $result = makeQuery($sql);
    if(!$result or mysql_num_rows($result) < 1) {
        return false;
    } else {
        while($row = mysql_fetch_assoc($result)) {
            array_push($rivi,$row);
        }
        return $rivi;
    }
    unset($rivi,$sql,$result,$row);
}
function get_sublink_array($tlid) {

    global $CFG; // Global $CFG values.
    $rivi = array();

    $sql = "SELECT id, title FROM ".$CFG->prefix."cms_subpages ";
    $sql .= "WHERE hide != '1' AND tlid='$tlid' ORDER BY sort ASC";

    $result = makeQuery($sql);
    if(!$result or mysql_num_rows($result) < 1) {
        return false;
    } else {
        while($row = mysql_fetch_assoc($result)) {
            array_push($rivi,$row);
        }
        return $rivi;
    }
    unset($rivi,$sql,$result,$row);
}

/*
 * function get_page(). Returns a html code of wanted page.
 * @param $page A page id of wanted page.
 * @return string $html Returns HTML code of wanted pageid.
*/
function get_page($page=0,$table="") {

    global $CFG;

    if(!$page) {
        $sql = "SELECT title, body, DATE_FORMAT(modified, '%e.%c.%Y') AS modified ";
        $sql .= "FROM ".$CFG->prefix."cms_pages WHERE isfp <> '0'";

        $result = makeQuery($sql);
        if(!$result or mysql_num_rows($result) < 1) {
            $html = get_string("defaultpage");
        } else {
            while($row = mysql_fetch_assoc($result)) {
                $html = stripslashes($row['body']);
                $html .= "<p>&nbsp;</p>\n";
                $html .= "<p>&nbsp;</p>\n";
                $html .= "<p>".get_string("lastmodified").": {$row['modified']}</p>\n";
            }
        }
    } else {
        if(empty($table)) {
            $table = "cms_pages";
        }
        $sql = "SELECT title, body, DATE_FORMAT(modified, '%e.%c.%Y') AS";
        $sql .= " modified FROM ".$CFG->prefix.$table." WHERE id='{$page}'";

        $result = makeQuery($sql);
        if(!$result or mysql_num_rows($result) < 1) {
            $html = get_string("err404");
        } else {
            while($row = mysql_fetch_assoc($result)) {
                $html = stripslashes($row['body']);
                $html .= "<p>&nbsp;</p>\n";
                $html .= "<p>".get_string("lastmodified").": {$row['modified']}</p>\n";
            }
        }
    }
    return $html;
    unset($html,$sql,$result);
}

/*
 * function get_news(). Generates a showt news list and prints out
 * first column of news and read more link. Returns a html code.
 * @param int $limit Limit of news to be generated.
 * @return string $html HTML code of wanted news headers.
 */
function get_news($limit) {
    global $CFG;

    $today = _datetime();
    $sql = "SELECT id, title, SUBSTRING(content,1,locate('</p>',content)+3) AS content,";
    $sql .= " DATE_FORMAT(modified, '%e.%c.%Y %H:%i:%s') AS modified FROM";
    $sql .= " ".$CFG->prefix."cms_news WHERE dated >= now() ORDER BY modified DESC LIMIT $limit";
    $result = makeQuery($sql);
    while($row = mysql_fetch_assoc($result)) {
        $html .= "<p><b>{$row['title']}</b></p>\n";
        $html .= stripslashes($row['content']);
        $html .= "<p><a href=\"".$CFG->web."/?news=true&id={$row['id']}\">".get_string("more")."</a></p>\n";
        $html .= "<p><small>({$row['modified']})</small></p>\n";
    }
    $html = strip_tags($html, allowed_tags("string"));
    return $html;
    unset($html,$sql,$result);
}
/*
* function get_one_news(). Returns a html code (whole page) of selected newsid.
* @param integer $id Id number of selected news.
* @return string $html HTML code of a selected news page.
*/
function get_one_news($id) {
    global $CFG;

    $sql = "SELECT title, content,";
    $sql .= " DATE_FORMAT(modified, '%e.%c.%Y %H:%i:%s') AS modified FROM";
    $sql .= " ".$CFG->prefix."cms_news WHERE id='$id'";

    $result = makeQuery($sql);
    if(!$result or mysql_num_rows($result) < 1) {
        $html = get_string("err404");
    } else {
        while($row = mysql_fetch_assoc($result)) {
            $html = "<h3>{$row['title']}</h3>\n";
            $html .= stripslashes($row['content']);
            $html .= "<p><small>{$row['modified']}</small></p>\n";
        }
    }
    return $html;
}
// Makes a dropdown menu <option>
function make_dropdown_menu($id, $field, $table) {

    global $CFG;
    if(empty($id) or empty($field) or empty($table)) {
        return false;
    }

    $sql = "SELECT id, $field FROM {$CFG->prefix}$table WHERE isfp != '1' ORDER BY id";
    $result = makeQuery($sql);
    if(!$result or mysql_num_rows($result) < 1) {
        return false;
    } else {
        while($row = mysql_fetch_array($result, MYSQL_NUM)) {
            print "\t<option value=\"{$row[0]}\"";
            print($row[0] == $id)?" selected>":">";
            print ($row[1]);
            print "</option>\n";
        }
    }
}
/* usage:
** $date = time();
** month_option($date);
*/
function day_option($d) {
    $day_array = getdate($d);
    for($i = 1; $i <= 31; $i++) {
        print "<option value=\"". sprintf("%'02d",$i). "\"";
        print(($day_array['mday'] == $i)?" selected":"");
        print ">$i</option>\n";
    }
    unset($day_array,$i);
}
function month_option($d) {
    $day_array = getdate($d);
    for($i = 1; $i <= 12; $i++) {
        print "<option value=\"". sprintf("%'02d",$i). "\"";
        print(($day_array['mon'] == $i)?" selected":"");
        print ">$i</option>\n";
    }
    unset($day_array,$i);
}
function year_option($d) {
    $day_array = getdate($d);
    $now_array = getdate(time());
    for($i = $now_array['year']; $i <= ($now_array['year']+8); $i++) {
        print "<option value=\"$i\"";
        print (($day_array['year'] == $i)?" selected":"");
        print ">$i</option>\n";
    }
    unset($day_array,$now_array,$i);
}
function hour_option($d) {
    $day_array = getdate($d);
    for($i = 0; $i < 24; $i++) {
        print "<option value=\"". sprintf("%'02d",$i). "\"";
        print(($day_array['hours'] == $i)?" selected":"");
        print ">". sprintf("%'02d",$i). "</option>\n";
    }
    unset($day_array);
}
function min_option($d) {
    $day_array = getdate($d);
    for($i = 0; $i <= 59; $i++) {
        print "<option value=\"". sprintf("%'02d",$i). "\"";
        print(($day_array['minutes'] == $i)?" selected":"");
        print ">". sprintf("%'02d",$i). "</option>\n";
    }
    unset($day_array);
}
?>